#include <iostream>
#include "Camera.h"

using namespace std;

    //Konstruktor
    Camera::Camera( void )
    {
        m_capture = cvCaptureFromCAM( 0 );
    }

    //Desturktor
    Camera::~Camera( void )
    {
        if (cameraOK())
        {
            cvReleaseCapture( &m_capture );
        }
    }
    
    bool Camera::cameraOK( void ) const
    {
        return (m_capture != NULL);
    }
    
    IplImage* Camera::getImage( void ) const
    {
        if (!cameraOK())
        {
            return NULL;
        }
        return cvQueryFrame( m_capture );
    }
    
    
    void Camera::setResolution( CvSize resolution )
    {
        CameraInterface::setResolution( resolution );

        cvSetCaptureProperty( m_capture, CV_CAP_PROP_FRAME_WIDTH,  resolution.width  );
        cvSetCaptureProperty( m_capture, CV_CAP_PROP_FRAME_HEIGHT, resolution.height );
	    //real Cam needs some time...
	    sleep(7);
    }
   

