#include <iostream>
#include <sstream>
#include "RobotInterface.h"


    CameraInterface* RobotInterface::getCamera() const
    {
	   return m_camera;
    }	
    
    SensorsInterface* RobotInterface::getSensors() const
    {
	   return m_sensors;
    }

    void RobotInterface::drive( const float distance )
    {
	   drive( distance, NORMAL_SPEED );
    }
    
    void RobotInterface::drive( const float distance, const unsigned int speed )
    {
	   int pulses = (int)(distance * PULSES_PER_METER);

	   stringstream outStream;
	   if (pulses > 0)
	   {
	       outStream <<  ">DPP," << speed << "," << speed << "," << pulses << ","<< pulses << "\n";
	   }
	   else
	   {
	       outStream <<  ">DPP,-" << speed << ",-" << speed << "," << pulses << ","<< pulses << "\n";
	   }
	   string command = outStream.str();
	   sendCommand( command );
	   gettimeofday( &m_stopTime, 0 );
       m_stopTime.tv_sec += (int)((fabs(distance) * 200.0 / speed)+0.5);  //enspricht 0.5m/s bei Geschwindigkeit 100%
    }
    
    void RobotInterface::turn( const float angle )
    {
        turn( angle, NORMAL_SPEED );
    }
    
    void RobotInterface::turn( const float angle, const unsigned int speed )
    {
        int pulses = (int)(fabs(angle) / (2.0*M_PI) * PULSES_PER_FULL_CIRCLE);
        stringstream outStream;
        outStream << ">DPP,";
        if ( angle < 0.0 )
        {
            outStream << speed << ",-" << speed << "," << pulses << ",-" << pulses << "\n";
        }
        else
        {
            outStream << "-" << speed << "," << speed  << ",-" << pulses << "," << pulses << "\n";
        }

        string command = outStream.str();

        sendCommand( command );
        gettimeofday( &m_stopTime, 0 );
        m_stopTime.tv_sec += (int)((angle / (2.0*M_PI) * 200.0 / fabs(speed))+0.5);  //enspricht 1/2 Umdrehung /s bei Geschwindigkeit 100%
    }
    
    void RobotInterface::stop( void )
    {
    	sendCommand(" ");
    	gettimeofday( &m_stopTime, 0 );
    	
    	//TODO: muss hiernach erst wieder ein "J" kommen? Testen....
    }

	
