
#ifndef SIMULATEDROBOT_H_
#define SIMULATEDROBOT_H_

#include <fstream>
#include <sys/time.h>
#include "RobotInterface.h"

using namespace std;

class SimulatedRobot : public RobotInterface
{
    
    public:
    
        SimulatedRobot( void );
        ~SimulatedRobot( void );
        
        bool robotOK( void ) const;
        
        void waitForStop( void ) const;
        
        void drive ( const float distance );
        void drive( const float distance, const unsigned int speed );

        void turn( const float angle );
        void turn( const float angle, const unsigned int speed );
        
    private:
    
        void sendCommand( const string s ) const;
        
    
};

#endif /*SIMULATEDROBOT_H_*/
